\documentclass[12pt]{report}
\usepackage{geometry}                % See geometry.pdf to learn the layout options. There are lots.
\geometry{letterpaper}                   % ... or a4paper or a5paper or ... 
\usepackage{graphicx}
\usepackage{amssymb}
\usepackage{amsmath}

\geometry{
 a4paper,
 total={170mm,257mm},
 left=20mm,
 top=20mm,
 }

\begin{document}
	
\title{Team Project One \\ IFT-7020 (Winter 2021) \\  Optimisation Combinatoire}
\date{21 February 2021}
\author{Bryan-Elliott Tam (111 133 067)\\Pankaj Kumar Singh (536 859 460)}
\maketitle

\newpage
\section{Problem One}

This problem is the popular puzzle called Instant Insanity. Solution can be seen as four cubes put on the top of each other.
Each face of this tower makes a rectangle of 4 cubes height and one cube width. Solution is visualized as matrix
created by four such rectangles. Each side of solution creates a column of solution matrix. Each solution is a 
group of four solutions, because by rotating this solution column by 90 degrees a new solution is obtained.\\

Constraint Satisfaction Problem (CSP) can be written as follows

\begin{equation}
P = <X, D, C>
\end{equation}

Where $X$ is $n$ tuple of the decision variable, $D$ is $n$ tuple of domain and $C$ is $t$ tuple of constraint.\\

For this analysis let there be total $n$ cubes. \\


\textbf{Variable}\\

Each element of this matrix is variable. Variable $X_{ij}$ represent the matrix  element in \\ 
the $i^{th}$ row and $j^{th}$ column, in turn it correspond to  $i^{th}$ cube and $j^{th}$ side face of that cube. Where $1 \leq i \leq 4$ and $1 \leq j \leq 6$. The $5,6$ index are the faces in the axis of the prisms.\\

\textbf{Domain}\\

The domain of variable  $X_{ij}$ is limited to the colors $\{red,yellow,bleu,green\}$\\

\textbf{Constraints}\\

For column  from 1 to 4 $j$ no two cube faces are the same $X_{ij} \neq X_{kj}$.

\begin{equation}
X_{ij} \neq X_{kj} \quad \forall 1 \leq j, k \leq 4
\end{equation}

It can be simplified by removing the redundancy, because of the symmetry of the constraint. With four cube it becomes... \\


for all the fours faces $j$
\begin{multline}\\
    X_{1j} \neq X_{2j} \wedge \\
    X_{1j} \neq X_{3j} \wedge \\
    X_{1j} \neq X_{4j} \wedge \\
    X_{2j} \neq X_{3j} \wedge \\
    X_{2j} \neq X_{4j} \wedge \\
    X_{3j} \neq X_{4j}\\
\end{multline}

The colour of cube face is changed by rotation. Constrains below the keep the cube colours consistent. It validates that the cube has  a number of faces with a certain colour. Constants $4*n$  are defined to represent the number of colours present on every cube.The form of the constants is $n\{color\}Cube\{index \ of \ the \ cube\}$ .\\

for all cube $i$
\begin{multline} \\
    count(X_{i},red) == nRedCube\{i\} \wedge \\
    count(X_{i},yellow) == nYellowCube\{i\} \wedge \\
    count(X_{i},green) == nGreenCube\{i\} \wedge \\
    count(X_{i},bleu) == nBleuCube\{i\}\\
\end{multline}

According to complexity of the variable we have $n\times6 \in \Theta(n)$ variables; $6$ faces with $n$ cube.\\

Now the complexity of the constraint, for the first constraint
\begin{multline} 
\\  4*((n-1)+(n-2)...+1) \\
    4*\sum_{i = 1}^{n-1} n-i \\
    4*(\sum_{i = 1}^{n-1} n - \sum_{i = 1}^{n-1} i) \\
    4*((n-1-1+1)*n - \frac{(n-1)*((n-1)+1)}{2} ) \\
    4*(n^2 - n -  \frac{(n-1)*((n-1)+1)}{2}) \\
    4* n^2 - n - \frac{(n-1)*n}{2}\\
    4*(n^2-n-\frac{n^2-n}{2}) \\
    4*(\frac{2*n^2-2n-(n^2-n)}{2})\\
    2*(n^2-3*n) \\
    2*(n*(n-3)) \\
\end{multline}

% Reference feuilled de note complexite algorithmique
The complexity has to be found using a limit, therefore we suppose that the complexity is $O(n^2)$. On simplifying the equation \\

\begin{multline} \\
    \frac{2*n*(n-3)}{n^2}\\
    \frac{2*(n-3)}{n}\\
    \frac{2n}{n} - \frac{3}{n}\\
    2 - \frac{3}{n}\\
\end{multline}
On applying the limit \\
\begin{equation}
    \lim_{n \to \infty}  2 - \frac{3}{n} = 2
\end{equation}

Therefore we conclude that this complexity is $O(n^2)$\\ 

For the second constraint\\

There are $4$ constraint for $n$ cube, so $O(n)$ \\

The complexity of the constraint is $O(n^2)+O(n) = O(n^2)$

\vspace{10mm}

%%%%%%%%%%%%%%%%%%%%
%.      Problem two section starts.        %
%%%%%%%%%%%%%%%%%%%%
\section{Problem Two}
\setcounter{equation}{0}

This is a scheduling problem. The goal is to minimize the cost and create a schedule for employees. For period $t$ and task $a$, there is a demand for $d_{ta}$ employees. Overcapacity cost is $C_{ta}(x_{ta}-d_{ta})$, where $x_{ta}$ is actual number of employees working on the task, $C_{ta}$ is overcapacity cost per employee. Under capacity cost is $c_{ta}(d_{ta}-x_{ta})$, where $c_{ta}$ is under capacity cost per employee\\

Cost calculation for total loss $L_{t}$ for period $t$ is as follows

\begin{equation}
L_{t} = if (x_{ta} > d_{ta})\ then\ C_{ta}(x_{ta}-d_{ta}) \ elseif\ (x_{ta} < d_{ta}) \ then\ c_{ta}(d_{ta}-x_{ta})\ else \ 0 
\end{equation}

\begin{equation}
	d_{ta} = C_{ta} = c_{ta} = 0 \implies X_{tj} = 0
\end{equation}

Sum of all losses  $L_{t}$ over $(0<t \leq P)$, where $P$ is Periods in a day, gives the total loss. The aim is to minimize this loss.\\

\textbf{Variable}\\

The solution is a schedule matrix for employee, where each row $i$ is an employee and columns $t$ is 15 minute time period. Each value in this matrix $X_{it}$ represent the state of employee during that period.\\

\textbf{Domain}\\

Variable $X_{it}$ can take values of $0\leq a \leq A$, where $a$ is the number of activity or $0$ for not working.\\

\textbf{Constraints}\\

An employee should work between 6 and 8 hours including pause and excluding dinner. Let $T_{i}$ be the total time employee actually works at the shop, which is sum of $t_{i}$ from start of work to the end of work, where $X_{it} \neq 0$.

\begin{equation}
 5:30 \ hour \leq T_{i} \leq 7:30 \ hour
\end{equation}

\begin{equation}
 T_{i} =  \sum_{t=k}^{n} t_{i}  \  where \ \sigma_{x_{t} \neq 0 }
\end{equation}

Equation (3) does not enforce any pattern in working periods. \\

Employee must work at least one hour in each stretch on same task \\

\begin{equation}
 if \ X_{it} \neq 0 \ then \ X_{it,..,t+3} \neq 0 \ and \ X_{it,..,t+3} = c 
\end{equation}

Where c is some activity number. \\


%%%%%%%%%%%%%%%%%%%%
%.      Working here                    .        %
%%%%%%%%%%%%%%%%%%%%




Employee should take $15minutes$ pause then dinner and $15minutes$ pause again in this order.\\
\begin{equation}  X_{it}=0  \end{equation}

Employee can not stop working on a task before one hour.\\

Employee can only change activity just after break or dinner.\\

Employee must work work before and after break and dinner.\\

\end{document}  
